<template>
  <TheHeader>
    <TheStat
      :active-count="activeTodos.length"
      :all-count="todo.length"
      :done-count="doneTodos.length"
    />
  </TheHeader>
  <TheFilter :active-filter="activeFilter" @set-filter="setFilter" />

  <main class="app-main">
    <TheAddTodo @add-task="addTask" />
    <TheTodoList :todos="filteredTodos" @remove="remove" @toggle-todo="toggleTodo" />
  </main>
</template>
<script setup lang="ts">
import TheHeader from "./components/TheHeader.vue";
import TheFilter from "./components/TheFilter.vue";
import TheTodoList from "./components/TheTodoList.vue";
import TheAddTodo from "./components/TheAddTodo.vue";
import TheStat from "./components/TheStat.vue";

import { useTask } from "./composables/useTask";
import { useFilter } from "./composables/useFilter";

const { todo, addTask, remove, toggleTodo } = useTask();
const { activeFilter, filteredTodos, setFilter, activeTodos, doneTodos } = useFilter(todo);
</script>
